/**********************************************
 * DCDT                       January 2002    *  
 *                                            *
 * DCDT_Main.cpp                              *
 *                                            *
 *                                            *
 **********************************************/

#include <DCDT_Agora.h>
#include <DCDT_Member.h>
#include <DCDT_Time.h>

#include "const.h"
#include "types.h"
#include <math.h>

#include "member_zero.h"
//#include "member_load_cpu.h"

#define STR_FILE_REPORT "report"

//static int current_loop;

struct cpu_load_measure_t {
  float start_time;
  float start_idle;
  float end_time;
  float end_idle;
  double avg_load; 
  float exec_time; 
};

void cpu_load_start( struct cpu_load_measure_t * clm){
  float a, b;
  FILE * fileUptime; 
    fileUptime=fopen("/proc/uptime","r");
  fscanf(fileUptime,"%f %f",&a, &b);
  fclose(fileUptime);

  clm->start_time = a; 
  clm->start_idle = b; 
  clm->exec_time = 0.0;
  clm->avg_load = 0.0;
};

void cpu_load_stop( struct cpu_load_measure_t * clm){
  float a, b;
  FILE * fileUptime; 
    fileUptime=fopen("/proc/uptime","r");
  fscanf(fileUptime,"%f %f",&a, &b);
  fclose(fileUptime);
  
  clm->end_time = a; 
  clm->end_idle = b; 
  clm->exec_time = clm->end_time - clm->start_time;

  printf("idle init %f, fin %f\n ", clm->start_idle, clm->end_idle);

  clm->avg_load = 100.0-(( (double)(clm->end_idle - clm->start_idle) / 
			   (double)clm->exec_time )*100.0);
};


int read_configuration(int argc, char** argv, struct parameters** params, FILE* report)
{

  // FILE* file_conf;
  struct parameters param;
  int num_threads=0;
  //int cont;
  *params=NULL;

  // file_conf=fopen(argv[1],"r");

  //while(!feof(file_conf))
  //{
  //fscanf(file_conf,"%d %d %d %d %d %ld\n",&cont, &param.standard, &param.mathFuncs, &param.memory, &param.io, &param.period);
  sscanf(argv[1],"%d",&num_threads);
  sscanf(argv[2],"%d",&param.standard);
  sscanf(argv[3],"%d",&param.mathFuncs);
  sscanf(argv[4],"%d",&param.memory);
  sscanf(argv[5],"%ld",&param.mem_size);
  sscanf(argv[6],"%ld",&param.period);
  sscanf(argv[7],"%ld",&param.num_loops);
  *params=(parameters*)malloc(sizeof(struct parameters)*num_threads);//+sizeof(struct parameters)*num_threads);
  //fprintf(report,"%d threads con: \n \top. frequenti:%d\n\top.matematiche:%d\n\top. memory:%d\n\top. disco:%d\n\tperiod:%ld\n",num_threads, param.standard, param.mathFuncs, param.memory, param.io,param.period);
  fprintf(report,"\n%d\t%d\t%d\t%d\t%ld\t%ld\t%ld\t",num_threads, 
	  param.standard, param.mathFuncs, param.memory, param.mem_size, 
	  param.period, param.num_loops);
  //printf("\n%d %d %d %d %ld %ld %ld\n",num_threads, param.standard, param.mathFuncs, param.memory, param.mem_size, param.period, param.num_loops);
  for (int i=0;i<num_threads;i++)
    {
      //printf("num_th:%d, cont:%d,i:%d\n",num_threads,cont,i);
      // param.id_thread=(char*)malloc(sizeof(char)*8);
      //sprintf(param.id_thread,"--%d--",i);
      param.id_thread=i;
      (*params)[i]=param;
      // printf("%s %d %d %d %d %ld %ld\n",param.id_thread, param.standard, param.mathFuncs, param.memory, param.mem_size, param.num_loops);
    }
  // num_threads+=cont;
  //}
  // fclose(file_conf);         */
  return num_threads;
}

/*
void write_results(struct results_t** res, int num_threads,long int num_loops, 
		   FILE* report,FILE * fdata, struct cpu_load_t* cpu_load, 
		   long int count_lost_deadline)
*/

void write_results(struct results_t** res, int num_threads,  int num_loops, 
		   FILE* report,FILE * fdata, struct cpu_load_measure_t * cpm, 
		   int count_lost_deadline)
{
  struct results_t* exec_data;
  double average_thread=0.0, jitter_thread=0.0;
  double *dev_average_th, *dev_jitter_th;
  double avEx=0, avJitter=0, deviationEx=0, deviationJitter=0, avLoad=0, devLoad=0;
  //  int count_cpu_load=0;
  int i, j;
  //  float exec_time = 0.0; 
  
  dev_average_th=(double*)malloc(sizeof(double)*num_threads);
  dev_jitter_th=(double*)malloc(sizeof(double)*num_threads);

  //  printf("num_loops=%ld\n",num_loops);

  //writting data file headers
  fprintf(fdata,"cycle\t");
  for (i=0;i<num_threads;i++)
    fprintf(fdata,"Exec(%d)\tJitter(%d)\t",i,i);
  fprintf(fdata,"time\t%%load");


  //write data from each thread in columns
  for (i=2;i<num_loops;i++)
    {
      fprintf(fdata,"\n%d\t",i);
      for (j=0;j<num_threads;j++)
	{
	  fprintf(fdata,"%d\t%d\t", ((struct results_t*)res[j])[i].execTime ,
		  ((struct results_t*)res[j])[i].jitter);
	  //	  printf("jitter=%f\n",((struct results_t*)res[j])[i].jitter);
	}

      /*
	fprintf(fdata,"%f\t%f",cpu_load[count_cpu_load].time,cpu_load[count_cpu_load].load);
	avLoad+=cpu_load[count_cpu_load].load;
	if (i==cpu_load[count_cpu_load].loop)
        count_cpu_load++;
      */
    }

  //  avLoad = fabs(avLoad/ ((double)num_loops-2));
  //  count_cpu_load--;
  /*
  //Calculate devLoad: deviation of Cpu Load
  for (i=0;i<count_cpu_load;i++)  //abs(num_loops/time_load_loops);i++)
    {
      devLoad+=(cpu_load[i].load-avLoad)*(cpu_load[i].load-avLoad)*
	(cpu_load[i].loop - (i==0?0:cpu_load[i-1].loop));
      aux=i;
    }
  devLoad=sqrt(devLoad/((double)(num_loops-3)));
  */

  // fprintf(fdata,"\ntime/load\t%f\t%f\n",cpu_load[count_cpu_load].time,cpu_load[count_cpu_load].load);

  fprintf(fdata,"\naver.");
  
  for (j=0;j<num_threads;j++)
    {
      exec_data=(struct results_t*)res[j];
      average_thread=0.0;
      jitter_thread=0.0;

      for (i=2;i<num_loops;i++)
	{ //Calculation of  average and jitter of each thread
	  int  a, b;
	  a = (int)(exec_data[i].execTime);
	  b = (int)(exec_data[i].jitter); 
	  average_thread = average_thread + (double)a;
	    jitter_thread = jitter_thread + (double)b;

	    /*
	      printf("cycle(%d) execTime=%f [%d], jitter=%f [%d]\n",i, (double)a, 
	      exec_data[i].execTime, (double)b ,exec_data[i].jitter);
	      
	      printf("average =%f, jitter=%f\n",average_thread, jitter_thread);
	      
	      //	  getchar();
	    */
	}

      // printf("av=%ld, jit=%ld",(long int)average_thread,(long int)jitter_thread);
      
      avEx+=average_thread;
      avJitter+=jitter_thread;
      average_thread/=(double)(num_loops-2);
      jitter_thread/=(double)(num_loops-2);
      
      // printf(" ,av=%ld, jit=%ld\n",(long int)average_thread,(long int)jitter_thread);
      
      //Calculation of  Standard deviation of each thread
      dev_average_th[j]=0.0;
      dev_jitter_th[j]=0.0;

      for (i=2;i<num_loops;i++)
	{
	  int  a, b;
	  a = (int)(exec_data[i].execTime);
	  b = (int)(exec_data[i].jitter); 
	  
	  dev_average_th[j]+=((double)a-average_thread)* 
	    ((double)a-average_thread);
	  dev_jitter_th[j]=((double)b-jitter_thread)* 
	    ((double)b-jitter_thread);

	  //	  printf("dejitter=%f\n",dev_jitter_th[j]);
	}

      dev_average_th[j]= sqrt(fabs(dev_average_th[j]/(double)(num_loops-3)));
      dev_jitter_th[j]= sqrt(fabs(dev_jitter_th[j]/(double)(num_loops-3)));
      fprintf(fdata,"\t%f\t%f",average_thread,jitter_thread);
    }
  fprintf(fdata,"\t\t%f",(float)avLoad);

  fprintf(fdata,"\ndev.");
  for (j=0;j<num_threads;j++)
    {
      fprintf(fdata,"\t%f\t%f",dev_average_th[j],dev_jitter_th[j]);
    }

  fprintf(fdata,"\t\t%f",(float)devLoad);

  fprintf(fdata,"\n");

  avEx=avEx /(double) ((num_loops-2)*num_threads);
  avJitter=avJitter / (double) ((num_loops-2)*num_threads);

  for (j=0;j<num_threads;j++)
    {
      exec_data=(struct results_t*)res[j];
      for (i=2;i<num_loops;i++)
	{
	  int  a, b;
	  a = (int)(exec_data[i].execTime);
	  b = (int)(exec_data[i].jitter); 
	  
          deviationEx+=((double)a-avEx)*((double)a-avEx);
          deviationJitter+= ((double)b-avJitter)*((double)b-avJitter);
	}
    }

  /*
  // setting the execution time
  for( i = 2; i<num_loops; i++){
    //    printf(" CPULOAD[%d] time = %f\n",i,  cpu_load[i].time);
    if (cpu_load[i].loop == -1) {
      //      printf("------> CPULOAD time = %f\n", cpu_load[i-1].time);
      exec_time = cpu_load[i-1].time;
      break;
    }
  }
  */
  
  deviationEx=sqrt(fabs(deviationEx /(double)(((num_loops-2)*num_threads)-1)));
  deviationJitter=sqrt(fabs(deviationJitter /(double)(((num_loops-2)*num_threads)-1)));

  fprintf(report,"%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d",avEx,deviationEx,
	  avJitter, deviationJitter,(float)cpm->avg_load, 0.0,
	  (float)cpm->exec_time, count_lost_deadline);
  //	  (float)cpu_load[++count_cpu_load].time, count_lost_deadline);

}



int main(int argc, char **argv)
{

  DCDT_Agora *agora;
  MemberZero **members;
  //  MemberLoadCpu *member_cpu_load;

  struct parameters* params=NULL;
  int num_threads=0;
  long int num_loops=0;
  long int period=0;
  struct results_t ** exec_data=NULL;
  //  struct cpu_load_t * cpu_load=NULL;
  FILE * report, *fdata;
  char* str_fdata=NULL;
  int count_lost_deadline=0;

  long int current_loop; 
  
  struct cpu_load_measure_t *cpu_load_m = NULL;

  //  long int mylong; 

  if (argc!=8)
    {
      printf("use:%s num_threads num_op_standard num_op_math num_op_memory mem_size period num_loops",
	     argv[0]);
      exit(0);
    }
  

  report=fopen(STR_FILE_REPORT,"a");
  if (ftell(report)==0)
    {
      fprintf(report,"#threads\t#standard_func\t#math_func\t#mem_func\tmem_size\tperiod\t#loops\tAv.ExTime(microsec.)\tDev.ExTime\tAv.Jitter\tDev.Jitter\tAv.Load\tDev.Load\tTotal_Time\t#Lost deadLine\n");
    }
  str_fdata=(char*)malloc(sizeof(char)*13+sizeof(argv[1])+sizeof(argv[2])+ 
			  sizeof(argv[3])+sizeof(argv[4])+sizeof(argv[5])+
			  sizeof(argv[6])+sizeof(argv[7]));
  sprintf(str_fdata,"%s_%s_%s_%s_%s_%s_%s.data",argv[1],argv[2],argv[3],
	  argv[4],argv[5],argv[6],argv[7]);
  fdata=fopen(str_fdata,"w");

  num_threads=read_configuration(argc, argv, &params,report);

  num_loops=params[0].num_loops;

  period = params[0].period;
  
  //  mylong = (long int)((double)(num_loops*period*14)/((double)(TIME_LOAD_MSECS*10000)));

  //  printf("Period = %ld, mylong = %ld\n", period, mylong);

  
  agora = new DCDT_Agora();

  

  //  printf("Let's allocating memory\n");
  exec_data = (struct results_t **)malloc(sizeof(struct results_t *)*num_threads);
  //  cpu_load = (struct cpu_load_t*)malloc(sizeof(struct cpu_load_t)* (num_loops+1));
  
  cpu_load_m = (struct cpu_load_measure_t *)malloc (sizeof(struct cpu_load_measure_t ));

  // start measuring the CPU load
  cpu_load_start(cpu_load_m);

  members=(MemberZero **)malloc(sizeof(MemberZero *)*num_threads);
  for (int i=0;i<num_threads;i++)
    {
      members[i] = new MemberZero(agora,&params[i], i, &current_loop);
      agora->AddMember(members[i]);
      agora->ActivateMember(members[i]);
    }

  //  member_cpu_load=new MemberLoadCpu(agora, cpu_load, &current_loop);
  //  agora->AddMember(member_cpu_load);
  //  agora->ActivateMember(member_cpu_load);
  //  agora->DeActivateMember(member_cpu_load);

  /*printf("\n\nPress a key and ''let's work, be proud...'' \n\n");
    getchar();
  */
  agora->LetsWork();

  //  member_cpu_load->DoYourJob(-1);
  //  Delay(100000);
  
  //  printf("Let's allocating memory\n");

  //  exec_data=(struct results_t **)malloc(sizeof(struct results_t *)*num_threads);

  for (int i=0;i<num_threads;i++)
    {
      exec_data[i]=(struct results_t*)members[i]->GetData();
      count_lost_deadline+=members[i]->getLostDeadLines();
    }

/*
  for(int i=0; i<=num_loops; i++)
    printf("cpuload[%d]: loop %d time =%f, load =%f\n",i, cpu_load[i].loop,
	   cpu_load[i].time, cpu_load[i].load);
*/

  //  printf("Let's poiting to memoryload \n");
  
  //  cpu_load=(struct cpu_load_t*)member_cpu_load->GetData();

  //  printf("Let's writing results \n");
  
  //  write_results(exec_data,num_threads,num_loops, report, fdata, cpu_load, count_lost_deadline);

  cpu_load_stop( cpu_load_m);

  write_results(exec_data,num_threads,num_loops,
		report, fdata, cpu_load_m, count_lost_deadline);
  fclose(fdata);
  fclose(report);

  //  printf("Let's remove members \n");
  for (int i=0;i<num_threads;i++)
    {
      agora->RemoveMember(members[i]);
    }
   
  //  printf("Let's remove member CPU_LOAD \n");
  
  //  agora->RemoveMember(member_cpu_load);

  Delay(20000);
  
  //  printf("Let's remove AGORA \n");
  delete agora;


  //  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
