#include <DCDT_Agora.h>
#include <DCDT_Member.h>
#include <DCDT_Time.h>

#include "member_one.h"

int main(int argc, char *argv[])
{
  
  DCDT_Agora *agora;
  MemberOne *member1;
  long period=0;
  char *filename=NULL;

  switch ( argc ) {
  case 1:
    break;

  case 2:
    period=atol(argv[1]);
    break;

  case 3:
    period=atol(argv[1]);
    filename=argv[2];
    break;

  default:
    printf ( "Usage: %s <period in us> <configuration>\nPeriod=100000 -> 0.1 sec.\n", argv[0] );
    exit ( 1 );
  }

  if ( filename != NULL )
    printf ( "Using configuration file: %s\n", filename );

  printf ( "member_one period = %ld\n", period );

  if ( filename != NULL )
    agora = new DCDT_Agora( filename );
  else
    agora = new DCDT_Agora();

  member1 = new MemberOne(agora, period);
  
  agora->AddMember(member1);
  
  agora->ActivateMember(member1);
  
  printf("Agora->LetsWork()\n");
  
  agora->LetsWork();
  
  printf ("Ended Agora->LetsWork()\n" );

  delete member1;
  
  delete agora;
  
  return 0;
}
