#include "DCDT_Channel_IP.h"

DCDT_Channel_IP::DCDT_Channel_IP(int AgoraID) : DCDT_Channel(AgoraID) {
    udp_sock = NULL;
    tcp_sock1 = tcp_sock2 = tcp_wsock = NULL;
    notify.payload_len = answer.payload_len = DATA_IP_LEN;
    localCD = remoteCD = NULL;
    startCD = NULL;
    udp_ready = false;
  };

DCDT_Channel_IP::~DCDT_Channel_IP() {
    //   if ( localCD )
    //      delete localCD;
    //
    //    if ( remoteCD )
    //      delete remoteCD;
  };

CommData_IP::CommData_IP(){
    data = new Data_IP();
    memset ( data, 0, sizeof(Data_IP) );
    TRC_PRINT( DCDT_TRC_COMM, TRC1, ("Creating CommData_IP %p data %p", this, data ));
};

CommData_IP::CommData_IP(int t_a, int t_p, int u_a, int u_p) {
    data = new Data_IP();
    data->tcp_addr = t_a;
    data->tcp_port = t_p;
    data->udp_addr = u_a;
    data->udp_port = u_p;
    TRC_PRINT( DCDT_TRC_COMM, TRC1, ("Creating CommData_IP %p data %p", this, data ));
};

CommData_IP::CommData_IP(Data_IP* d) {
    //data = d;
    data = new Data_IP();
    memcpy ( data, d, sizeof(Data_IP) );
    TRC_PRINT( DCDT_TRC_COMM, TRC1, ("Creating CommData_IP %p data %p", this, data ));
};

CommData_IP::CommData_IP(CommData_IP *cd) {
    data = new Data_IP();
    data->tcp_addr = cd->data->tcp_addr;
    data->tcp_port = cd->data->tcp_port;
    data->udp_addr = cd->data->udp_addr;
    data->udp_port = cd->data->udp_port;
    TRC_PRINT( DCDT_TRC_COMM, TRC1, ("Creating CommData_IP %p data %p", this, data ));
};

CommData_IP::~CommData_IP() {
  if ( data ) {
    TRC_PRINT( DCDT_TRC_COMM, TRC1, ("CommData_IP %p Deleting data %p", this, data ));
    delete data;
  }
}

