/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
**!!!                                                                   
**!!!                   INFO SOLUTION SPA                     
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                    
**!!! PROJECT       : ROBY                                 
**!!!                                                                    
**!!! CLASS         : ModuleDispatch
**!!!
**!!! PACKAGE       : Ethnos                                           
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                   
**!!! FILE NAME     : ModuleDispatch.cpp
**!!!                                                                   
**!!! CREATION DATE : 31.10.2001         
**!!!                                                                   
**!!! AUTHOR        : P.M.  Roby  Team                             
**!!!                                                                   
**!!!                                                                   
**!!!___________________________________________________________________
**!!!                                                                   
**!!! SPECS ON DOCS : <Spec. Doc Name A>  Rev.: AA.aa                   
**!!!                                                                     
**!!!                 <Spec. Doc Name B>  Rev.: BB.bb                   
**!!!                ............                                       
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/


/*----------------------------------------------------------------------
 *--------------------- SYSTEM  INCLUDE FILES --------------------------
 *---------------------------------------------------------------------*/
#include <string.h>
/*----------------------------------------------------------------------
 *--------------------- PROJECT INCLUDE FILES --------------------------
 *---------------------------------------------------------------------*/
#include "ModuleDispatch.h"
#include "const.h"
/*----------------------------------------------------------------------
 *-----------------------  DEFINE MACRO  -------------------------------
 *---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 *-----------------------  TYPES DECLARATION  --------------------------
 *---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 *--------------------  STATIC VARIABLE DECLARATION  -------------------
 *---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 *--------------------  STATIC FUNCTION DECLARATION  -------------------
 *---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 *--------------------  CONSTRUCTOR DESTRUCTOR  ------------------------
 *---------------------------------------------------------------------*/
ModuleDispatch :: ModuleDispatch (char* config_file, string host_name):  DCDT_Agora(config_file)
{   
  mHostName = host_name;
  if(mHostName.find("./",0,2) != string::npos)
    mHostName.erase(0,2);

  // Initialize Expert Id Counter
  ExpertIdCounter=0;
  // Initialize Memory Management Variable
    // Memory Area Management Initialization
  MemoryCounter=0;
  for (int count=0;count<MAX_MEMORY_AREA;count++){
    Memory[count].Name=0;
    Memory[count].CreatorId=0;
    Memory[count].Length=0;
    Memory[count].Flag=NONE;
  }
}
  
ModuleDispatch ::  ~ModuleDispatch ()
{
} 
 /*----------------------------------------------------------------------
 *-------------------- PUBLIC METHODS DEFINITIONS ----------------------
 *---------------------------------------------------------------------*/
 /*----------------------------------------------------------------------
 *-------------------- PUBLIC METHODS DEFINITIONS ----------------------
 *---------------------------------------------------------------------*/
/*---------------------------------------------------------------------- 
**---                                                            
**--- METHOD  NAME  :  MD_MemSetFlag
**---                                                            
**---------------------------------------------------------------------- 
**---                                                         
**--- INPUT PARAM   : int Name,ExpertId,MemoryFlag
**---                                                         
**--- OUTPUT PARAM  : 
**---                                                         
**--- RETURN PARAM  :   Return Value
**---                                                         
**---------------------------------------------------------------------- 
**---                                                                   
**--- OVERVIEW      :
**---                
**---                                                                   
**-------------------------------------------------------------------------
*/

int ModuleDispatch::MD_MemSetFlag(int Name,MemFlag NewFlag)
{
 
  // Check if the Memory Area Named Name exists
  // Then sets its Memory Flag to New value
  /************************************
   **---  WARNING THIS IS NOT A DYNAMIC
   **---  BEHAVIOUR::: PAY ATTENTION ??
   **----------------------------------
   **/
  for (int Count=0;Count<MemoryCounter;Count++) {
    if (Memory[Count].Name==Name) {
      Memory[Count].Flag=NewFlag;
      return (RC_OK);
    }
  }
  return (RC_ERROR);
}
/*---------------------------------------------------------------------- 
**---                                                            
**--- METHOD  NAME  :  MD_MemGetFlag
**---                                                            
**---------------------------------------------------------------------- 
**---                                                         
**--- INPUT PARAM   : int Name
**---                                                         
**--- OUTPUT PARAM  : 
**---                                                         
**--- RETURN PARAM  : Flag
**---                                                         
**---------------------------------------------------------------------- 
**---                                                                   
**--- OVERVIEW      : Gets the Length of the particoular Memory
**---                area
**---                                                                   
**-------------------------------------------------------------------------
*/

MemFlag  ModuleDispatch::MD_MemGetFlag(int Name)
{
  // Check if the Memory Area Named Name exists
  for (int Count=0;Count<MemoryCounter;Count++) {
    if (Memory[Count].Name==Name) {
      return Memory[Count].Flag;
    }
  }
  return (NONE); 
} 
/*---------------------------------------------------------------------- 
**---                                                            
**--- METHOD  NAME  :  MD_MemSetLength
**---                                                            
**---------------------------------------------------------------------- 
**---                                                         
**--- INPUT PARAM   : int Name,ExpertId
**---                                                         
**--- OUTPUT PARAM  : 
**---                                                         
**--- RETURN PARAM  :   Return Value
**---                                                         
**---------------------------------------------------------------------- 
**---                                                                   
**--- OVERVIEW      :
**---                
**---                                                                   
**-------------------------------------------------------------------------
*/

int ModuleDispatch::MD_MemSetLength(int Name,int ExpertId,int Length)
{
  if (Length>0) {
    if (MemoryCounter<MAX_MEMORY_AREA) {
      Memory[MemoryCounter].CreatorId=ExpertId;
      Memory[MemoryCounter].Name=Name;
      Memory[MemoryCounter].Length=Length;
      MemoryCounter++;
      return RC_OK;
    } else return RC_ERROR;
  } else  {// Check if the Memory Area Named Name exists
    // Then sets its Memory Length to Zero
    /************************************
     **---  WARNING THIS IS NOT A DYNAMIC
     **---  BEHAVIOUR::: PAY ATTENTION ??
     **----------------------------------
     **/
    for (int Count=0;Count<MemoryCounter;Count++) {
      if (Memory[Count].Name==Name) {
	Memory[Count].Length=0;
	return RC_OK;
      }
    }
    return RC_ERROR;
  } 
}
/*---------------------------------------------------------------------- 
**---                                                            
**--- METHOD  NAME  :  MD_MemGetLength
**---                                                            
**---------------------------------------------------------------------- 
**---                                                         
**--- INPUT PARAM   : int Name
**---                                                         
**--- OUTPUT PARAM  : 
**---                                                         
**--- RETURN PARAM  : Return Value
**---                                                         
**---------------------------------------------------------------------- 
**---                                                                   
**--- OVERVIEW      : Gets the Length of the particoular Memory
**---                area
**---                                                                   
**-------------------------------------------------------------------------
*/

int ModuleDispatch::MD_MemGetLength(int Name)
  {
  // Check if the Memory Area Named Name exists
  for (int Count=0;Count<MemoryCounter;Count++) {
    if (Memory[Count].Name==Name) {
      return Memory[Count].Length;
    }
  }
  return RC_ERROR; 
} 

/*---------------------------------------------------------------------- 
**---                                                            
**--- METHOD  NAME  :  MD_GetExpertId
**---                                                            
**---------------------------------------------------------------------- 
**---                                                         
**--- INPUT PARAM   : 
**---                                                         
**--- OUTPUT PARAM  : 
**---                                                         
**--- RETURN PARAM  :   
**---                                                         
**---------------------------------------------------------------------- 
**---                                                                   
**--- OVERVIEW      :
**---                
**---                                                                   
**-------------------------------------------------------------------------
*/

int ModuleDispatch::MD_GetExpertId()
{
  return ExpertIdCounter++;
}
