#ifndef GESTIONECONFIGURAZIONE_H_
#define GESTIONECONFIGURAZIONE_H_

#include <boost/program_options.hpp>
#include <iostream>
#include <fstream>
#include <iterator>
#include <string>

namespace po = boost::program_options;
using namespace std;

class GestioneConfigurazione{
	static string devSerial;
	static string devJoypad;
	static string calibJoypad;
	static string fileHokuyoL;
	static string fileHokuyoR;
	static string dcdtConfFile;

	static string brianctof;
	static string brianshapectof;
	static string brianpredicate;
	static string brianpredicateactions;
	static string briancando;
	static string brianbehaviour;
	static string brianwant;
	static string briansftoc;
	static string briansftocshape;
	static string audioFile;
	
	static string artoolkitCalibFile;
	static double artoolkitTagDimension;

	static string matrixInversionParameterFile;
	static string matrixInversionParameterFileTmp;

	static string tagRelationFileTmp;
	static string tagRelationFileMeanTmp;
	static string matrixLogParameterFile;
	static string absoluteCoordinateTagRelationFile;
	static string absoluteCoordinateWheelchairToCameraRelationFile;
	
	static string 	sequencerConfigFile;
	
	static string imageNamePrefix;
	static string imageNameSubfix;
	static string imageNameFormat;
	static bool cameraSimulation;

	static string fireIdevice;

	static bool   saveFrame;
	static string saveImageNamePrefix;
	static string saveImageNameSubfix;
	static string saveImageNameFormat;

	static string logFile;
	static string matrixSdrAbsoluteWrtTagTmp;
	
	static string spikeConfigFile;
	static string poseConfigFile;

	static string imuDeviceName;
	static string imuConfigFile;

	public:
	static 	int 	init(string path,int ac,char *av[]);
	inline 	static 	string 	getFileHokuyoL(){return fileHokuyoL;};
	inline 	static 	string 	getFileHokuyoR(){return fileHokuyoR;};
	inline 	static 	string 	getDevSerial(){return devSerial;};
	inline 	static 	string 	getDevJoypad(){return devJoypad;};
	inline 	static 	string 	getCalibJoypad(){return calibJoypad;};
	inline 	static 	string 	getDcdtConfFile(){return dcdtConfFile;};
	inline 	static 	string 	getBrianCtofFile(){return brianctof;};
	inline 	static 	string 	getBrianShapeCtofFile(){return brianshapectof;};
	inline 	static 	string 	getBrianPredicateFile(){return brianpredicate;};
	inline 	static 	string 	getBrianPredicateActionsFile(){return brianpredicateactions;};
	inline 	static 	string 	getBrianCandoFile(){return briancando;};
	inline 	static 	string 	getBrianBehaviourFile(){return brianbehaviour;};
	inline 	static 	string 	getBrianWantFile(){return brianwant;};
	inline 	static 	string 	getBrianSftocFile(){return briansftoc;};
	inline 	static 	string 	getBrianSftocShapeFile(){return briansftocshape;};
	inline 	static 	string 	getAudioConfigFile(){return audioFile;};
	inline 	static 	string 	getArtoolkitCalibFile(){return artoolkitCalibFile;};
	inline 	static 	double 	getArtoolkitTagDimension(){return artoolkitTagDimension;};
	inline 	static 	string 	getMatrixInversionParameterFile(){return matrixInversionParameterFile;};
	inline 	static 	string  getMatrixInversionParameterFileTmp(){return matrixInversionParameterFileTmp;};
	inline 	static 	string 	getAbsoluteCoordinateTagRelationFile(){return absoluteCoordinateTagRelationFile;};
	inline 	static 	string 	getTagRelationFileTmp(){return tagRelationFileTmp;};
	inline 	static 	string 	getTagRelationFileMeanTmp(){return tagRelationFileMeanTmp;};
	inline 	static 	string 	getAbsoluteCoordinateWheelchairToCameraRelationFile(){return absoluteCoordinateWheelchairToCameraRelationFile;};
	inline 	static 	string 	getMatrixSdrAbsoluteWrtTagFileTmp(){return matrixSdrAbsoluteWrtTagTmp;};
	inline 	static	string  getLogFile(){return logFile;};
	inline 	static	string  getSequencerConfigFile(){return sequencerConfigFile;};
	
	inline 	static bool  getCameraSimulation(){return cameraSimulation;}
	inline 	static string getImageNamePrefix(){return imageNamePrefix;};
	inline 	static string getImageNameSubfix(){return imageNameSubfix;};
	inline 	static string getImageNameFormat(){return imageNameFormat;};

	inline 	static bool  getSaveFrame(){return saveFrame;}
	inline 	static string getSaveImageNamePrefix(){return saveImageNamePrefix;};
	inline 	static string getSaveImageNameSubfix(){return saveImageNameSubfix;};
	inline 	static string getSaveImageNameFormat(){return saveImageNameFormat;};

	inline static string getFireIdevice(){return fireIdevice;};


	inline 	static string getSpikeConfigFile(){return spikeConfigFile;};
	inline 	static string getPoseConfigFile(){return 	poseConfigFile;};
	inline 	static 	string getImuDeviceName(){return imuDeviceName;}
	inline 	static 	string getImuConfigFile(){return imuConfigFile;}
	inline 	static string getMatrixLogParameterFile(){return matrixLogParameterFile;};
	static 	string 	toString();
};

#endif
