#ifndef brianExpert_h
#define brianExpert_h

#include <string.h>

#include <const.h>

#include <brian.h>
#include <getFuzzy.h>



#ifdef SIM
#include <Sequenced.h>
#endif

#include "StringModuleMember.h"
#include <const.h>

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern int MessageLineNum;

class BrianExpert: public StringModuleMember
#ifdef SIM
, public Sequenced
#endif
{
 public:
  BrianExpert(ModuleDispatch* dis,long period, bool refbox);
  ~BrianExpert();

  void RunInit();
  void RunDuty();
  void RunClose();

  void ParseStringMessages();
  void FillMessages(command_list * cl, 
		    action_list * al,
		    predicate_list * linkcadl, 
		    weight_want_list* linkwwl,
		    predicate_list* linkpdl);

  void SetValue(const char * name, float val, float rel);

 private:
 
  // function used to keep values in cdl up to date
  void BuildData(command_list* cl);

  MrBrian * TheBrian;

  void AddBehaviorData(string name, float cando_value, float want_value);
  void AddFuzzyData(string name,float value,float reliability);
  void AddCommandData(string name, float value);

  map<string,float> mCL;

  //variables used to configure the module
  float not_so_reliable;
  int mStatus;
  float old_ball_x, old_ball_y;
  unsigned int mWaitingTime;
  unsigned int mAreaTime;
  bool mIsDefending;
  bool mIsWaiting;
  float mRefbox;
  
  ofstream logfile; //*wiim*

};

#endif
