#ifndef MotorExpert_h

	#define MotorExpert_h

	//#include "MotorMessageManager.h"
	#include "StringModuleMember.h"

	#include <sys/time.h>
	#include <stdlib.h> 
	#include <stdio.h>
	#include <const.h>
	#include <msg.h>


	#ifdef SYNCHRO
		#include <SynchroActuationManager.h>
	#endif

	#ifdef TRISKAR
		#include <TriskarActuationManager.h>
	#endif

	#ifdef GIANO
		#include <GianoActuationManager.h>
	#endif

	#ifdef METAMORPHIC
		#include <MetamorphicActuationManager.h>
	#endif

	#ifdef SIM
		#include <Sequenced.h>
	#endif


	class MotorExpert : public StringModuleMember
	#ifdef SYNCHRO
		  , public SynchroActuationManager
	#endif
	#ifdef TRISKAR
		  , public TriskarActuationManager
	#endif
	#ifdef GIANO
		  , public GianoActuationManager
	#endif
	#ifdef METAMORPHIC
		  , public MetamorphicActuationManager
	#endif
	#ifdef SIM
		  , public Sequenced
	#endif
	{
	 	public:
  			MotorExpert (ModuleDispatch* kernel, int period);
  			~MotorExpert ();
   		void RunInit();
   		void RunClose();
   		void RunDuty();
   		long elapsed(int);
   		void settimer(int);

   		void SendMotorMessage();

 		private:
 		struct timeval last_render[10];
   		void AddOdometryData(string name, float value);
   		float old_Tan;
   		float old_Rot;

	};


#endif
