#include "PositionDummyExpert.h"

#include <iostream>



PositionDummyExpert::PositionDummyExpert(ModuleDispatch* kernel,int period) : 
  StringModuleMember(kernel,period,"position")
{
  printf("\nPositionDummyExpert built");
  fflush(stdout);
};

PositionDummyExpert::~PositionDummyExpert()
{
  printf("\nPositionDummyExpert destroyed");
  fflush(stdout);
};

void PositionDummyExpert::RunInit()
{
 	AddMessageRequest( MSG_TO_MOTION,LOCAL );
  
	lastsec=0;
	lastusec=0;
	lasttanspeed=0;
	lastrotspeed=0;
	
	rob.x=STARTX;
	rob.y=STARTY;
	rob.a=STARTANGLE;

  	printf("\nPositionDummyExpert initialized");
  	fflush(stdout);
};

/* ***********************************
   
   DoYourDuty()

   *********************************** */

void PositionDummyExpert::RunDuty()
{
  	unsigned char* buffer;
	char* buf;
	float f;
	int i;
	float e;
	float tanspeed,rotspeed;
  
  	if(ReceiveLastMessage(MSG_TO_MOTION, buffer,true) > 0)
    {
    	for(i=0;buffer[i]!=NULL;i++){
			;
		}
    	buf=(char*)malloc(i+1);
    	strcpy(buf,(char*)buffer);
    	
    	//printf ("\nricevuto messaggio da PositionDummyExpert: \n%s\n",buf);
    	e=((float)elapsedtime(buf))/1000000;
   		//printf("elapsed=%f\n",e);
   		
    	if(strtovalue(buf,"TanSpeed ",&f) || strtovalue(buf,"RotSpeed ",&f) ){
 //   		printf ("\nricevuto messaggio da PositionDummyExpert: \n%s\n",buf);
   			f=0;
    		if(strtovalue(buf,"TanSpeed ",&f)){
    			lasttanspeed=f*8; //la calibrazione giusta si fa con il robot
			}else{
				lasttanspeed=0;
			}
			f=0;
       		if(strtovalue(buf,"RotSpeed ",&f)){
       			lastrotspeed=f*3;
			}else{
				lastrotspeed=0;
			}
		}else{
			lasttanspeed=0;
			lastrotspeed=0;
		}
		
		//integro la velocità per ottenere la posizione
		rob.a+=lastrotspeed*e;
		rob.a=norangle(rob.a);
		
		rob.x+=lasttanspeed*(cos(degtorad(rob.a)))*e;
		rob.y+=lasttanspeed*(sin(degtorad(rob.a)))*e;
		
		
		//evito di mandare troppi messaggi
		te+=e;
		if(te>0.01){
			//printf("rob.x=%f, rob.y=%f rob.a=%f\n",rob.x,rob.y,rob.a);
			//printf("d=%f, a=%f\n",ppdistance(rob,goal).d,ppdistance(rob,goal).a);
			te=0;
			NewMessage(MSG_POSITION,POS_DATA);
			mCurrentMessage<<"posx "<<rob.x<<" posy "<<rob.y<<" angle "<<rob.a<<" \n";
	//		mCurrentMessage<<" DG "<<ppdistance(rob,goal).d<<" DA "<<ppdistance(rob,goal).a
			CloseMessage();
			SendAllStringMessages();
			
		/*	NewMessage(MSG_TO_WIIMOTE,POS_DATA);
			mCurrentMessage<<" posx "<<rob.x<<" posy "<<rob.y<<" angle "<<rob.a<<" \n";
			mCurrentMessage << "</MESSAGE>\n" << '\0';
			SendAllStringMessages();*/ //evito: uso variabile rob condivisa
		}
		
		//printf("lastrot=%f lasttan=%f angle=%f anglerad=%f posx=%f posy=%f\n",lastrotspeed,lasttanspeed,angle,degtorad(angle),posx,posy);
    }
};

void PositionDummyExpert::RunClose()
{
  printf("\nPositionDummyExpert closed");
  fflush(stdout);
};

long PositionDummyExpert::elapsedtime(char* buf)
{
	long sec,usec,e;
	int i;
	int t=0;
	char* buf10=(char*)malloc(50);
	char* buf11=(char*)malloc(50);
	char* buf12=(char*)malloc(50);

	sscanf(buf,"%*s%*s%*s%*s%*s%*s%*s%*s%*s%s",buf10);
	for(i=1;buf10[i]!=NULL;i++){
		if(buf10[i]=='_'){
			i++;
			t=i;
			//i+=2;
		}
		if (t==0){
			buf11[i-1]=buf10[i];
		}else{
			buf12[i-t]=buf10[i];
		}
	}
	buf11[t-2]=NULL;
	buf12[i-t]=NULL;
	
	sscanf(buf11,"%d",&sec);
	sscanf(buf12,"%d",&usec);
	
	free (buf10);
	free (buf11);
	free (buf12);
	
	if(lastsec==0){
		lastsec=sec;
		lastusec=usec;
		return 0;
	}else{
		e=(((sec-lastsec)*1000000)+(usec-lastusec));
		lastsec=sec;
		lastusec=usec;
		return e;
	}
}
	



