%option noyywrap

%{
#include "BrianExpert.h"

#include "briangram.tab.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern int brianlex();

extern void brianparser (BrianExpert* brian);

void brianlex_memory(const char* src, BrianExpert* brian)
{
//   cout << src << endl;
   YY_BUFFER_STATE buf_state;
   buf_state = brian_scan_string(src);
   brianparser (brian);
   brian_delete_buffer(buf_state);

}

//extern int MessageLineNum;

%}


%option noyywrap
%pointer


TEXT [a-zA-Z_][a-zA-Z0-9_]*
BLANK [" "\t]
DIGIT [0-9]
SPACE [" "]
%x HEADER
%%

"#".*           /* eat up comments */
{BLANK}+        /* eat blank spaces */
\n              /* eat up all newline*/ {MessageLineNum++;}

"<MESSAGE"	{ BEGIN(HEADER); 
		  return OPEN_MESSAGE_HEADER;}
<HEADER>">"     { BEGIN(INITIAL); 
		  return CLOSE_HEADER;}
<HEADER>.	{}
"</MESSAGE>"    { return CLOSE_MESSAGE;}
"="             { return EQUAL;}
"id"            { return MESSAGE_ID;}
"timestamp"     { return TIMESTAMP;}
"sender"        { return SENDER;}
"module"        { return MODULE;}

"<D>"           { return OPEN_DATUM;}
"</D>"          { return CLOSE_DATUM;}
"<E>"           { return OPEN_ENCODER;}
"</E>"          { return CLOSE_ENCODER;}

{TEXT}          {  
		  brianlval.string = (char*)strdup(briantext); 
		  return NAME; 
		}

[-+]?{DIGIT}+(\.{DIGIT}+)?	{	
				  *(briantext+brianleng)='\0';
				  brianlval.value=atof(briantext);
				  return VALUE;
				}

%%