#ifndef ARToolKitWrapper_h
#define ARToolKitWrapper_h

#include "Matrix3DRotoTraslation.h"
#include <string>
#include <vector>

#ifdef INC_ART
#include "ARToolKitPlus/TrackerSingleMarkerImpl.h"
using namespace ARToolKitPlus;
#endif

using namespace std;

class ARToolKitWrapper{
public:
	ARToolKitWrapper(string cameraCfgFile, double tagDim);
	~ARToolKitWrapper();
	int processImage(unsigned char * img); // restituisce il numero di tag trovato
	Matrix3DRotoTraslation * getMatrix3D();	
	inline int getMarkerId(){return markerId;};

	static const int img_width  		= 640;
	static const int img_height 		= 480;
	static const double all_zero_esp 	= 1e-6;

	double* getXPoint(){return xpoint;};
	double* getYPoint(){return ypoint;};
private:
	double tagDimension;
	int markerId;
	Matrix3DRotoTraslation *matrix;

	double xpoint[4];
	double ypoint[4];

#ifdef INC_ART
	TrackerSingleMarkerImpl<6,6,6, 1, 8> *tracker;
#else
	void *tracker;
#endif



};

#endif
