#include "GestioneCoordinateAssolute.h"
#include "MatrixFunctions.h"

GestioneCoordinateAssolute::GestioneCoordinateAssolute(){
	postMatrixMult=new Matrix3DRotoTraslation();
	result=NULL;
	presult=NULL;
}

GestioneCoordinateAssolute::~GestioneCoordinateAssolute(){
	while( !tagMat.empty() ) {
		delete tagMat.begin()->second;
		tagMat.erase( tagMat.begin() );
	}
	if(result!=NULL)delete result;
	if(presult!=NULL)delete presult;
	delete postMatrixMult;
}

void GestioneCoordinateAssolute::addTag(int tagNum,double x,double y,double z,double a,double b,double c){
	if( tagMat.find(tagNum) != tagMat.end() ){
		delete tagMat[tagNum];
	}
	Param3DRotoTraslation *p=new Param3DRotoTraslation();
	p->setX(x);
	p->setY(y);
	p->setZ(z);
	p->setA(a);
	p->setB(b);
	p->setC(c);
	tagMat[tagNum]= toMatrix3DRotoTraslation(p);
	//print3DMatrix(tagMat[tagNum]);
	delete p;
}

void GestioneCoordinateAssolute::setPostMatrix(double x,double y,double z,double a,double b,double c){
	delete postMatrixMult;
	Param3DRotoTraslation *p=new Param3DRotoTraslation();
	p->setX(x);
	p->setY(y);
	p->setZ(z);
	p->setA(a);
	p->setB(b);
	p->setC(c);
	postMatrixMult= toMatrix3DRotoTraslation(p);
	delete p;
	
}

int GestioneCoordinateAssolute::getAbsolute(int tag,Matrix3DRotoTraslation *src){
	Matrix3DRotoTraslation * tmp;
	if(result!=NULL){
		delete result;
		delete presult;
		result=NULL;
		presult=NULL;
	}
	if( tagMat.find(tag) == tagMat.end() ) return -1;
  	tmp=multMatrix3D(tagMat[tag],src);
	result=multMatrix3D(tmp,postMatrixMult);
	presult=toParam3DRotoTraslation(result);
	
	delete tmp;
  	return 0;
}

double GestioneCoordinateAssolute::getX(){return presult->getX();};
double GestioneCoordinateAssolute::getY(){return presult->getY();};
double GestioneCoordinateAssolute::getA(){return presult->getA();};

