#include <InverseMatrixCorrection.h>
#include "MatrixFunctions.h"
InverseMatrixCorrection::InverseMatrixCorrection(){
	result=NULL;
}

InverseMatrixCorrection::~InverseMatrixCorrection(){
	while( !tagParam.empty() ) {
		delete (*tagParam.begin()).second ;
		tagParam.erase( tagParam.begin() );
	}
	if(result!=NULL)delete result;
}

void InverseMatrixCorrection::addTag(int numTag,double z,double b,double c){
	map<int,Param3DRotoTraslation *>::iterator iter = tagParam.find(numTag);
	if( iter != tagParam.end() ) {
		delete iter->second ;
	}
	tagParam[numTag]=new Param3DRotoTraslation();
	tagParam[numTag]->setZ(z);
	tagParam[numTag]->setB(b);
	tagParam[numTag]->setC(c);
}

int InverseMatrixCorrection::getInverseMatrix(Matrix3DRotoTraslation *in,int numTag){
	int res=-1;
	Param3DRotoTraslation *pin=toParam3DRotoTraslation(in);
	if(result!=NULL)delete result;
	result=NULL;	
	map<int,Param3DRotoTraslation *>::iterator iter = tagParam.find(numTag);
	if( iter != tagParam.end() ) {
		tagParam[numTag]->setX(pin->getX());
		tagParam[numTag]->setY(pin->getY());
		tagParam[numTag]->setA(pin->getA());
		result=invMatrix3D(tagParam[numTag]);
		res=0;
	}
	delete pin;
	return res;
}

int InverseMatrixCorrection::getCorrectedMatrix(Matrix3DRotoTraslation *in,int numTag){
	int res=-1;
	Param3DRotoTraslation *pin=toParam3DRotoTraslation(in);
	if(result!=NULL)delete result;
	result=NULL;	
	map<int,Param3DRotoTraslation *>::iterator iter = tagParam.find(numTag);
	if( iter != tagParam.end() ) {
		tagParam[numTag]->setX(pin->getX());
		tagParam[numTag]->setY(pin->getY());
		tagParam[numTag]->setA(pin->getA());
		result=toMatrix3DRotoTraslation(tagParam[numTag]);
		res=0;
	}
	delete pin;
	return res;
}

